diff --git a/gcc/analyzer/impl-4.cc b/gcc/analyzer/impl-4.cc
index b12102c..5089c16 100644
--- a/gcc/analyzer/impl-4.cc
+++ b/gcc/analyzer/impl-4.cc
@@ -1883,11 +2264,17 @@ program_state::operator= (const program_state &other)
 {
   m_path_state = other.m_path_state;
 
+  delete m_region_model;
+  if (other.m_region_model)
+    m_region_model = new region_model (*other.m_region_model);
+  else
+    m_region_model = NULL;
+
   // TODO: eliminate existing things
   gcc_assert (m_checker_states.length () == 0);
 
   int i;
-  sm_state_map *smap;
+  sm_state_map<path_var> *smap;
   FOR_EACH_VEC_ELT (other.m_checker_states, i, smap)
     m_checker_states.safe_push (smap->clone ());
 
@@ -1900,8 +2287,12 @@ hashval_t
 program_state::hash () const
 {
   hashval_t result = m_path_state.hash ();
+
+  if (m_region_model)
+    result ^= m_region_model->hash ();
+
   int i;
-  sm_state_map *smap;
+  sm_state_map<path_var> *smap;
   FOR_EACH_VEC_ELT (m_checker_states, i, smap)
     result ^= smap->hash ();
   return result;
@@ -1914,15 +2305,26 @@ program_state::operator== (const program_state &other) const
 {
   if (!(m_path_state == other.m_path_state))
     return false;
-  int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
-    if (!(*smap == *other.m_checker_states[i]))
+
+  if (m_region_model)
+    {
+      if (other.m_region_model == NULL)
+	return false;
+      if (!(*m_region_model == *other.m_region_model))
+	return false;
+    }
+  else if (other.m_region_model)
+    return false;
+
+  int i;
+  sm_state_map<path_var> *smap;
+  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
+    if (!(*smap == *other.m_checker_states[i]))
       return false;
   return true;
 }
 
-/* FIXME.  */
+/* Print a compact representation of this state to PP.  */
 
 void
 program_state::print (const extrinsic_state &ext_state,
@@ -1931,8 +2333,15 @@ program_state::print (const extrinsic_state &ext_state,
   pp_printf (pp, "ps: %s", m_path_state.to_str ().c_str ());
   pp_newline (pp);
 
+  if (m_region_model)
+    {
+      pp_printf (pp, "rmodel: ");
+      m_region_model->print (pp);
+      pp_newline (pp);
+    }
+
   int i;
-  sm_state_map *smap;
+  sm_state_map<path_var> *smap;
   FOR_EACH_VEC_ELT (m_checker_states, i, smap)
     {
       if (!smap->is_empty_p ())
@@ -1950,10 +2359,100 @@ std::string
 program_state::to_str (const extrinsic_state &ext_state) const
 {
   pretty_printer pp;
+  pp_format_decoder (&pp) = default_tree_printer;
   print (ext_state, &pp);
   return std::string (pp_formatted_text (&pp));
 }
 
+/* Dump a multiline representation of this state to PP.  */
+
+void
+program_state::dump (const extrinsic_state &ext_state,
+		     pretty_printer *pp) const
+{
+  // FIXME: multiline format?
+  pp_printf (pp, "ps: %s", m_path_state.to_str ().c_str ());
+  pp_newline (pp);
+
+  if (m_region_model)
+    {
+      pp_printf (pp, "rmodel: ");
+      m_region_model->dump_to_pp (pp);
+    }
+
+  int i;
+  sm_state_map<path_var> *smap;
+  FOR_EACH_VEC_ELT (m_checker_states, i, smap)
+    {
+      if (!smap->is_empty_p ())
+	{
+	  pp_printf (pp, "%s: ", ext_state.get_name (i));
+	  smap->print (ext_state.get_sm (i), pp);
+	  pp_newline (pp);
+	}
+    }
+}
+
+/* Implementation of purge_criteria for using state_purge_map.
+
+   Purge state within a path_state using PURGE_MAP for POINT.
+   Use the sm-states within OLD_STATE to avoid purging path_vars
+   that have any sm-state.  */
+
+class purge_at_point_criteria : public psn::purge_criteria
+{
+public:
+  purge_at_point_criteria (const program_point &point,
+			   const state_purge_map *purge_map,
+			   const extrinsic_state &ext_state,
+			   const program_state &old_state)
+  : m_point (point),
+    m_flat_point (point),
+    m_purge_map (purge_map),
+    m_ext_state (ext_state),
+    m_old_state (old_state)
+  {
+    m_flat_point.m_call_string = call_string ();
+  }
+
+  bool should_purge_p (path_var pv) const FINAL OVERRIDE
+  {
+    if (TREE_CODE (pv.m_tree) != SSA_NAME)
+      return false;
+    if (pv.m_stack_depth != m_point.get_stack_depth ())
+      return false;
+
+    if (!m_purge_map)
+      return false;
+
+    const state_purge_per_ssa_name &per_var_data
+      = m_purge_map->get_data_for_ssa_name (pv.m_tree);
+    if (!per_var_data.needed_at_point_p (m_flat_point))
+      {
+	/* Don't purge vars that have sm state, to avoid
+	   losing leak complaints.  */
+	int i;
+	sm_state_map<path_var> *smap;
+	FOR_EACH_VEC_ELT (m_old_state.m_checker_states, i, smap)
+	  {
+	    const state_machine &sm = m_ext_state.get_sm (i);
+	    if (!sm.can_purge_p (smap->get_state (pv)))
+	      return false;
+	  }
+
+	return true;
+      }
+    return false;
+  }
+
+private:
+  const program_point &m_point;
+  program_point m_flat_point;
+  const state_purge_map *m_purge_map;
+  const extrinsic_state &m_ext_state;
+  const program_state &m_old_state;
+};
+
 /* FIXME.
    Generate a simpler version of THIS, discarding state that's no longer
    relevant at POINT.
@@ -1962,36 +2461,118 @@ program_state::to_str (const extrinsic_state &ext_state) const
    irrelevant state (e.g. at the end of functions).  */
 
 program_state
-program_state::prune_for_point (const exploded_graph &eg,
+program_state::prune_for_point (exploded_graph &eg,
 				const program_point &point) const
 {
-  /* FIXME: for now a hack: purge all states at exit nodes (which won't work
-     interprocedurally).  */
-#if 0
-  if (const supernode *supernode = point.get_supernode ())
-    if (supernode->return_p ())
-      return program_state (eg.m_ext_state);
-#endif
+  function *fun = point.get_function ();
+  if (!fun)
+    return *this;
+
+  /* The points in the state map don't have call strings, so flatten
+     accordingly.  */
+  program_point flat_point (point);
+  flat_point.m_call_string = call_string ();
+
+  program_state new_state (*this);
+
+  purge_at_point_criteria criteria (point, eg.get_purge_map (),
+				    eg.get_ext_state (),
+				    *this);
+  int num_purged = new_state.m_path_state.purge (criteria);
+  eg.log ("path_vars purged: %i", num_purged);
 
-  // FIXME: what about leak detection, though?
+  eg.get_global_stats ()->m_path_vars_purged++;
+  stats *per_fn_stats = eg.get_or_create_function_stats (point.get_function ());
+  per_fn_stats->m_path_vars_purged++;
+
+  // FIXME: state maps also
+  int i;
+  sm_state_map<path_var> *smap;
+  int num_sm_purged = 0;
+  FOR_EACH_VEC_ELT (new_state.m_checker_states, i, smap)
+    {
+      const state_machine &sm = eg.get_ext_state ().get_sm (i);
+      num_sm_purged += smap->purge (sm, criteria);
+    }
+  eg.log ("num_sm_purged: %i", num_sm_purged);
 
+  if (new_state.m_region_model)
+    {
 #if 0
-  {
-    function *fun = point.get_function ();
-    if (fun)
-      {
-	auto_cfun sentinel (fun);
-	debug_immediate_uses ();
-	/* FIXME: maybe do the pruning here: we only know what state will be
-	   important when in conjunction with a program_point.  */
-      }
-  }
+      if (eg.get_logger ())
+	new_state.m_region_model->dump_to_pp (eg.get_logger_pp ());
 #endif
+      purge_stats stats;
+
+      const state_purge_map *pm = eg.get_purge_map ();
+      if (pm)
+	{
+	  region_id_set purgeable_ssa_regions (new_state.m_region_model);
+	  region_id frame_rid
+	    = new_state.m_region_model->get_current_frame_id ();
+	  frame_region *frame
+	    = new_state.m_region_model->get_region <frame_region>(frame_rid);
+
+	  /* FIXME: move to a member of region_model, once the state_purge_map
+	     etc decls are visible there.  */
+
+	  auto_vec<tree> ssa_names_to_purge;
+	  for (frame_region::map_t::iterator iter = frame->m_map.begin ();
+	       iter != frame->m_map.end ();
+	       ++iter)
+	    {
+	      tree var = (*iter).first;
+	      region_id rid = (*iter).second;
+	      if (TREE_CODE (var) == SSA_NAME)
+		{
+		  const state_purge_per_ssa_name &per_ssa
+		    = pm->get_data_for_ssa_name (var);
+		  if (!per_ssa.needed_at_point_p (flat_point))
+		    {
+		      purgeable_ssa_regions.add_region (rid);
+		      ssa_names_to_purge.safe_push (var);
+		      eg.log ("purging RID: %i for %qE", rid.as_int (), var);
+		      // FIXME: we also need to remove the region from the map
+		      // note that we're mid-traversal: this is done in unbind
+		      // below
+		    }
+		}
+	    }
 
+	  /* Unbind the regions from the frame's map of vars-to-regions.  */
+	  tree var;
+	  FOR_EACH_VEC_ELT (ssa_names_to_purge, i, var)
+	    frame->unbind (var);
 
-  return *this;
+	  /* Purge the regions.  Nothing should point to them, and they
+	     should have no children, as they are for SSA names.  */
+	  new_state.m_region_model->purge_regions (purgeable_ssa_regions,
+						   &stats);
+	}
+
+      /* Purge unused svalues.  */
+      new_state.m_region_model->purge_svalues (&stats);
+
+      eg.log ("num svalues purged: %i", stats.m_num_svalues);
+      eg.log ("num regions purged: %i", stats.m_num_regions);
+      eg.log ("num equiv_classes purged: %i", stats.m_num_equiv_classes);
+      eg.log ("num constraints purged: %i", stats.m_num_constraints);
+    }
+
+  return new_state;
+}
+
+/* FIXME.  */
+
+void
+program_state::validate () const
+{
+  m_path_state.validate ();
+  if (m_region_model)
+    m_region_model->validate ();
 }
 
+
 ////////////////////////////////////////////////////////////////////////////
 
 /* FIXME.  */
@@ -2010,7 +2591,8 @@ exploded_node::dump_dot (graphviz_out *gv) const
   pp_printf (pp, "EN: %i", m_index);
   pp_newline (pp);
 
-  m_ps.m_point.print (pp);
+  format f (true);
+  m_ps.m_point.print (pp, f);
   pp_newline (pp);
 
   m_ps.m_state.print (m_ext_state, pp);
@@ -2121,10 +2703,63 @@ exploded_node::dump_dot_id (pretty_printer *pp) const
   pp_printf (pp, "exploded_node_%i", m_index);
 }
 
+/* Dump a multiline representation of this node to PP.  */
+
+void
+exploded_node::dump_to_pp (pretty_printer *pp) const
+{
+  pp_printf (pp, "EN: %i", m_index);
+  pp_newline (pp);
+
+  format f (true);
+  m_ps.m_point.print (pp, f);
+  pp_newline (pp);
+
+  m_ps.m_state.dump (m_ext_state, pp);
+  pp_newline (pp);
+}
+
+/* Dump a multiline representation of this node to FILE.  */
+
+void
+exploded_node::dump (FILE *fp) const
+{
+  pretty_printer pp;
+  pp_format_decoder (&pp) = default_tree_printer;
+  pp_show_color (&pp) = pp_show_color (global_dc->printer);
+  pp.buffer->stream = fp;
+  dump_to_pp (&pp);
+  pp_flush (&pp);
+}
+
+/* Dump a multiline representation of this node to stderr.  */
+
+DEBUG_FUNCTION void
+exploded_node::dump () const
+{
+  dump (stderr);
+}
+
+/* FIXME.  */
+// is there a pre-canned way to do this?
+
+static bool
+fndecl_has_gimple_body_p (tree fndecl)
+{
+  if (fndecl == NULL_TREE)
+    return false;
+
+  cgraph_node *n = cgraph_node::get (fndecl);
+  if (!n)
+    return false;
+
+  return n->has_gimple_body_p ();
+}
+
 /* FIXME.  */
 
 program_state
-exploded_node::on_stmt (const exploded_graph &eg) const
+exploded_node::on_stmt (exploded_graph &eg) const
 {
   const program_point &point = m_ps.m_point;
   const program_state &old_state = m_ps.m_state;
@@ -2136,16 +2771,36 @@ exploded_node::on_stmt (const exploded_graph &eg) const
   const gimple *stmt = point.get_stmt ();
   int stack_depth = point.get_stack_depth ();
 
-  int i;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (old_state.m_checker_states, i, smap)
+  /* Update cfun and input_location in case of ICE: make it easier to
+     track down which source construct we're failing to handle.  */
+  auto_cfun sentinel (point.get_function ());
+  input_location = stmt->location;
+
+  int sm_idx;
+  sm_state_map<path_var> *smap;
+  FOR_EACH_VEC_ELT (old_state.m_checker_states, sm_idx, smap)
     {
-      const state_machine &sm = m_ext_state.get_sm (i);
+      const state_machine &sm = m_ext_state.get_sm (sm_idx);
+      const sm_state_map<path_var> &old_smap
+	= *old_state.m_checker_states[sm_idx];
+      sm_state_map<path_var> *new_smap = new_state.m_checker_states[sm_idx];
       impl_sm_context ctxt (eg, sm, this,
 			    &new_state,
-			    *old_state.m_checker_states[i],
-			    new_state.m_checker_states[i]);
-      sm.on_stmt (&ctxt, point.m_supernode, stmt);
+			    old_smap, new_smap);
+      /* Allow the state_machine to handle the stmt.  */
+      if (!sm.on_stmt (&ctxt, point.m_supernode, stmt))
+	{
+	  /* For those stmts that were not handled by the state machine.  */
+	  if (const gcall *call = dyn_cast <const gcall *> (stmt))
+	    {
+	      tree callee_fndecl = gimple_call_fndecl (call);
+	      // TODO: maybe we can be smarter about handling function pointers?
+
+	      if (!fndecl_has_gimple_body_p (callee_fndecl))
+		new_smap->purge_for_unknown_fncall (eg, sm, call, callee_fndecl,
+						    new_ps);
+	    }
+	}
     }
 
   if (const gassign *assign = dyn_cast <const gassign *> (stmt))
@@ -2181,9 +2836,9 @@ exploded_node::on_stmt (const exploded_graph &eg) const
 	    /* If we see a comparison, evaluate it based on what we know along
 	       this path, and record the result, if known.  */
 	    tree rhs2 = gimple_assign_rhs2 (assign);
-	    equiv_class_id rhs1_ec_id
+	    psn::equiv_class_id rhs1_ec_id
 	      = new_ps->get_or_add_equiv_class (path_var (rhs1, stack_depth));
-	    equiv_class_id rhs2_ec_id
+	    psn::equiv_class_id rhs2_ec_id
 	      = new_ps->get_or_add_equiv_class (path_var (rhs2, stack_depth));
 	    tristate t = new_ps->eval_condition (rhs1_ec_id, op, rhs2_ec_id);
 	    if (eg.get_logger ())
@@ -2208,6 +2863,9 @@ exploded_node::on_stmt (const exploded_graph &eg) const
 	  }
 	  break;
 	}
+
+      /* TODO: working on having region model handle all assignments.  */
+      on_assignment_for_region_model (eg, assign, old_state, &new_state);
     }
 
   if (const greturn *return_ = dyn_cast <const greturn *> (stmt))
@@ -2221,29 +2879,46 @@ exploded_node::on_stmt (const exploded_graph &eg) const
 		       new_ps->make_path_var (rhs),
 		       old_state,
 		       &new_state);
+      on_return_for_region_model (eg, return_, old_state, &new_state);
     }
 
   if (const gcall *call = dyn_cast <const gcall *> (stmt))
     {
       /* Debugging/test support.  */
       if (is_named_call_p (call, "__dump_constraints", 0))
-	inform (stmt->location, "__dump_constraints: %s",
-		new_ps->to_str ().c_str ());
-
-      /* Handle the builtin "__analyzer_eval" by evaluating the input
-	 and dumping as a dummy warning, so that test cases can use dg-warning
-	 to validate the result (and so unexpected warnings will lead to DejaGnu
-	 failures.  */
-      if (is_named_call_p (call, "__analyzer_eval", 1))
 	{
+	  inform (stmt->location, "__dump_constraints: %s",
+		  new_ps->to_str ().c_str ());
+	}
+      else if (is_named_call_p (call, "__analyzer_dump", 0))
+	{
+	  /* Handle the builtin "__analyzer_dump" by dumping state
+	     to stderr.  */
+	  dump ();
+	}
+      else if (is_named_call_p (call, "__analyzer_eval", 1))
+	{
+	  /* Handle the builtin "__analyzer_eval" by evaluating the input
+	     and dumping as a dummy warning, so that test cases can use dg-warning
+	     to validate the result (and so unexpected warnings will lead to DejaGnu
+	     failures.  */
 	  tree t_arg = gimple_call_arg (call, 0);
 	  tristate t
-	    = new_ps->dump_condition (t_arg, NE_EXPR, integer_zero_node);
+	    = (new_state.m_region_model
+	       ? new_state.m_region_model->eval_condition (t_arg,
+							   NE_EXPR,
+							   integer_zero_node)
+	       : new_ps->dump_condition (t_arg, NE_EXPR, integer_zero_node));
 	  warning_at (call->location, 0, "%s", t.as_string ());
 	}
+      else if (is_named_call_p (call, "__analyzer_break", 0))
+	{
+	  raise (SIGINT); // FIXME: cross-platform way to do this?
+	  //gcc_unreachable (); // FIXME: compare to a hard breakpoint
+	}
+      on_call_for_region_model (eg, call, old_state, &new_state);
     }
 
-
   return new_state;
 }
 
@@ -2261,11 +2936,54 @@ exploded_node::on_assignment (const exploded_graph &eg,
       eg.log ("rhs: %s", rhs.to_str ().c_str ());
     }
 
+#if 0
+  if (TREE_CODE (lhs.m_tree) != SSA_NAME
+      && TREE_CODE (lhs.m_tree) != RESULT_DECL
+      && TREE_CODE (lhs.m_tree) != VAR_DECL)
+    return;
+#endif
+
   new_state->m_path_state.on_assignment (lhs, rhs);
 
   copy_sm_state (eg, lhs, rhs, old_state, new_state);
 }
 
+/* FIXME.  */
+
+void
+exploded_node::on_assignment_for_region_model (const exploded_graph &eg,
+					       const gassign *stmt,
+					       const program_state &old_state,
+					       program_state *new_state) const
+{
+  if (new_state->m_region_model)
+    new_state->m_region_model->on_assignment (stmt);
+}
+
+/* FIXME.  */
+
+void
+exploded_node::on_call_for_region_model (const exploded_graph &eg,
+					 const gcall *stmt,
+					 const program_state &old_state,
+					 program_state *new_state) const
+{
+  if (new_state->m_region_model)
+    new_state->m_region_model->on_call (stmt);
+}
+
+/* FIXME.  */
+
+void
+exploded_node::on_return_for_region_model (const exploded_graph &eg,
+					   const greturn *stmt,
+					   const program_state &old_state,
+					   program_state *new_state) const
+{
+  if (new_state->m_region_model)
+    new_state->m_region_model->on_return (stmt);
+}
+
 /* Copy SM state (if any) from RHS to LHS.  */
 
 void
@@ -2289,8 +3007,8 @@ exploded_node::copy_sm_state (const exploded_graph &eg,
   for (unsigned i = 0; i < ext_state.m_checkers.length (); i++)
     {
       const state_machine &sm = ext_state.get_sm (i);
-      const sm_state_map *src_smap = old_state.m_checker_states[i];
-      sm_state_map *dst_smap = new_state->m_checker_states[i];
+      const sm_state_map<path_var> *src_smap = old_state.m_checker_states[i];
+      sm_state_map<path_var> *dst_smap = new_state->m_checker_states[i];
       state_machine::state_t rhs_state = src_smap->get_state (rhs);
       dst_smap->set_state (&new_state->m_path_state, lhs, rhs_state, rhs);
       if (eg.get_logger ())
@@ -2319,7 +3037,7 @@ exploded_node::copy_sm_state (const exploded_graph &eg,
    Update NEXT_POINT accordingly (updating the call string).  */
 
 bool
-exploded_node::on_edge (const exploded_graph &eg,
+exploded_node::on_edge (exploded_graph &eg,
 			const superedge *succ,
 			program_point *next_point,
 			program_state *next_state) const
@@ -2392,6 +3110,11 @@ public:
   leak_stmt_finder (const exploded_graph &eg, path_var pv)
   : m_eg (eg), m_pv (pv) {}
 
+  stmt_finder *clone () const FINAL OVERRIDE
+  {
+    return new leak_stmt_finder (m_eg, m_pv);
+  }
+
   const gimple *find_stmt (const exploded_path &epath)
     FINAL OVERRIDE
   {
@@ -2475,7 +3198,7 @@ private:
    for top-level functions.  */
 
 void
-exploded_node::detect_leaks (const exploded_graph &eg) const
+exploded_node::detect_leaks (exploded_graph &eg) const
 {
   JIT_LOG_FUNC_1 (eg.get_logger (), "EN: %i", m_index);
 
@@ -2495,7 +3218,7 @@ exploded_node::detect_leaks (const exploded_graph &eg) const
       {
 	if (eg.get_logger ())
 	  eg.log ("new_ps before escapes: %s", new_ps->to_str ().c_str ());
-	equiv_class_id ec_id
+	psn::equiv_class_id ec_id
 	  = new_ps->get_or_add_equiv_class (path_var (result, stack_depth));
 	new_ps->recursively_mark_as_escaping (ec_id);
 	if (eg.get_logger ())
@@ -2504,7 +3227,7 @@ exploded_node::detect_leaks (const exploded_graph &eg) const
   }
 
   int i;
-  equiv_class *ec;
+  psn::equiv_class *ec;
   FOR_EACH_VEC_ELT (new_ps->m_equiv_classes, i, ec)
     {
       if (eg.get_logger ())
@@ -2543,7 +3266,7 @@ exploded_node::detect_leaks (const exploded_graph &eg) const
       leak_stmt_finder stmt_finder (eg, best_pv);
 
       int i;
-      sm_state_map *smap;
+      sm_state_map<path_var> *smap;
       FOR_EACH_VEC_ELT (old_state.m_checker_states, i, smap)
 	{
 	  const state_machine &sm = m_ext_state.get_sm (i);
@@ -2564,7 +3287,7 @@ exploded_node::detect_leaks (const exploded_graph &eg) const
    in the exploded graph.  */
 
 bool
-program_point::on_edge (const exploded_graph &eg,
+program_point::on_edge (exploded_graph &eg,
 			const superedge *succ)
 {
   JIT_LOG_FUNC (eg.get_logger ());
@@ -2626,7 +3349,7 @@ program_point::on_edge (const exploded_graph &eg,
 /* FIXME.  */
 
 bool
-program_state::on_edge (const exploded_graph &eg,
+program_state::on_edge (exploded_graph &eg,
 			const exploded_node &enode,
 			const superedge *succ)
 {
@@ -2648,6 +3371,15 @@ program_state::on_edge (const exploded_graph &eg,
       return false;
     }
 
+  if (m_region_model)
+    if (!m_region_model->apply_constraints_for_edge (*succ,
+						     last_stmt))
+      {
+	eg.log ("edge to SN: %i is impossible due to region_model constraints",
+		succ->m_dest->m_index);
+	return false;
+      }
+
   /* FIXME: the above is setting ECs for args/params on calls, but not
      updating states.  should we call on_assignment instead.
      Also, where should it happen for return values at returns?
@@ -2726,7 +3458,7 @@ program_state::on_edge (const exploded_graph &eg,
   /* Pass the edge to the various state machines to see if any transitions
      or warnings occur.  */
   int i;
-  sm_state_map *old_smap;
+  sm_state_map<path_var> *old_smap;
   FOR_EACH_VEC_ELT (old_state.m_checker_states, i, old_smap)
     {
       const state_machine &sm = eg.get_ext_state ().get_sm (i);
